diff -cr sendmail-8.9.0/src/alias.c sendmail-8.9.1/src/alias.c
*** sendmail-8.9.0/src/alias.c	Tue May 19 16:36:09 1998
--- sendmail-8.9.1/src/alias.c	Mon Jun  8 14:24:55 1998
***************
*** 13,19 ****
  # include "sendmail.h"
  
  #ifndef lint
! static char sccsid[] = "@(#)alias.c	8.90 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  
--- 13,19 ----
  # include "sendmail.h"
  
  #ifndef lint
! static char sccsid[] = "@(#)alias.c	8.92 (Berkeley) 6/5/98";
  #endif /* not lint */
  
  
***************
*** 101,111 ****
  		a->q_flags |= QVERIFIED;
  		return;
  	}
! 	message("aliased to %s", shortenstring(p, 203));
  	if (LogLevel > 9)
  		sm_syslog(LOG_INFO, e->e_id,
  			"alias %.100s => %s",
! 			a->q_paddr, shortenstring(p, 203));
  	a->q_flags &= ~QSELFREF;
  	if (tTd(27, 5))
  	{
--- 101,111 ----
  		a->q_flags |= QVERIFIED;
  		return;
  	}
! 	message("aliased to %s", shortenstring(p, MAXSHORTSTR));
  	if (LogLevel > 9)
  		sm_syslog(LOG_INFO, e->e_id,
  			"alias %.100s => %s",
! 			a->q_paddr, shortenstring(p, MAXSHORTSTR));
  	a->q_flags &= ~QSELFREF;
  	if (tTd(27, 5))
  	{
***************
*** 380,386 ****
  	if (stat(buf, &stb) < 0 || stb.st_mtime < mtime || attimeout)
  	{
  		/* database is out of date */
! 		if (AutoRebuild && stb.st_ino != 0 && stb.st_uid == geteuid())
  		{
  			bool oldSuprErrs;
  
--- 380,388 ----
  	if (stat(buf, &stb) < 0 || stb.st_mtime < mtime || attimeout)
  	{
  		/* database is out of date */
! 		if (AutoRebuild && stb.st_ino != 0 &&
! 		    (stb.st_uid == geteuid() ||
! 		     (geteuid() == 0 && stb.st_uid == TrustedFileUid)))
  		{
  			bool oldSuprErrs;
  
diff -cr sendmail-8.9.0/src/clock.c sendmail-8.9.1/src/clock.c
*** sendmail-8.9.0/src/clock.c	Tue May 19 16:36:07 1998
--- sendmail-8.9.1/src/clock.c	Thu Jun  4 14:51:31 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)clock.c	8.33 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)clock.c	8.34 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 158,163 ****
--- 158,164 ----
  **		calls the next function in EventQueue.
  */
  
+ /* ARGSUSED */
  static SIGFUNC_DECL
  tick(sig)
  	int sig;
diff -cr sendmail-8.9.0/src/collect.c sendmail-8.9.1/src/collect.c
*** sendmail-8.9.0/src/collect.c	Tue May 19 16:36:05 1998
--- sendmail-8.9.1/src/collect.c	Thu Jun  4 14:32:01 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)collect.c	8.87 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include <errno.h>
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)collect.c	8.89 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  # include <errno.h>
***************
*** 159,164 ****
--- 159,166 ----
  
  	for (;;)
  	{
+ 		extern int chompheader __P((char *, bool, HDR **, ENVELOPE *));
+ 
  		if (tTd(30, 35))
  			printf("top, istate=%d, mstate=%d\n", istate, mstate);
  		for (;;)
***************
*** 311,318 ****
  				istate, mstate, buf);
  		switch (mstate)
  		{
- 			extern int chompheader __P((char *, bool, HDR **, ENVELOPE *));
- 
  		  case MS_UFROM:
  			mstate = MS_HEADER;
  #ifndef NOTUNIX
--- 313,318 ----
***************
*** 354,360 ****
--- 354,363 ----
  				bp++;
  			*bp = '\0';
  			if (bitset(H_EOH, chompheader(buf, FALSE, hdrp, e)))
+ 			{
  				mstate = MS_BODY;
+ 				goto nextstate;
+ 			}
  			break;
  
  		  case MS_BODY:
***************
*** 434,449 ****
  			sm_syslog(LOG_NOTICE, e->e_id,
  			    "collect: %s on connection from %.100s, sender=%s: %s",
  			    problem, host,
! 			    shortenstring(e->e_from.q_paddr, 203),
  			    errstring(errno));
  		if (feof(fp))
  			usrerr("451 collect: %s on connection from %s, from=%s",
  				problem, host,
! 				shortenstring(e->e_from.q_paddr, 203));
  		else
  			syserr("451 collect: %s on connection from %s, from=%s",
  				problem, host,
! 				shortenstring(e->e_from.q_paddr, 203));
  
  		/* don't return an error indication */
  		e->e_to = NULL;
--- 437,452 ----
  			sm_syslog(LOG_NOTICE, e->e_id,
  			    "collect: %s on connection from %.100s, sender=%s: %s",
  			    problem, host,
! 			    shortenstring(e->e_from.q_paddr, MAXSHORTSTR),
  			    errstring(errno));
  		if (feof(fp))
  			usrerr("451 collect: %s on connection from %s, from=%s",
  				problem, host,
! 				shortenstring(e->e_from.q_paddr, MAXSHORTSTR));
  		else
  			syserr("451 collect: %s on connection from %s, from=%s",
  				problem, host,
! 				shortenstring(e->e_from.q_paddr, MAXSHORTSTR));
  
  		/* don't return an error indication */
  		e->e_to = NULL;
diff -cr sendmail-8.9.0/src/conf.c sendmail-8.9.1/src/conf.c
*** sendmail-8.9.0/src/conf.c	Tue May 19 16:36:09 1998
--- sendmail-8.9.1/src/conf.c	Thu Jun 25 23:09:42 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)conf.c	8.428 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)conf.c	8.431 (Berkeley) 6/25/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 247,252 ****
--- 247,253 ----
  		DefGid = 1;			/* option g */
  		setdefuser();
  	}
+ 	TrustedFileUid = 0;
  	if (tTd(37, 4))
  		printf("setdefaults: DefUser=%s, DefUid=%d, DefGid=%d\n",
  		       DefUser != NULL ? DefUser : "<1:1>",
***************
*** 889,928 ****
  	}
  #endif
  
  	/* if the service file doesn't work, use an absolute fallback */
! #ifdef _USE_DEC_SVC_CONF_
    punt:
! #endif
  	for (svcno = 0; svcno < MAXMAPACTIONS; svcno++)
  		mapreturn[svcno] = 0;
  	svcno = 0;
  	if (strcmp(service, "aliases") == 0)
  	{
  		maptype[svcno++] = "files";
! #ifdef AUTO_NIS_ALIASES
! # ifdef NISPLUS
  		maptype[svcno++] = "nisplus";
! # endif
! # ifdef NIS
  		maptype[svcno++] = "nis";
  # endif
- #endif
  		return svcno;
  	}
  	if (strcmp(service, "hosts") == 0)
  	{
! # if NAMED_BIND
  		maptype[svcno++] = "dns";
! # else
! #  if defined(sun) && !defined(BSD) && !defined(_USE_SUN_NSSWITCH_)
  		/* SunOS */
  		maptype[svcno++] = "nis";
  #  endif
- # endif
  		maptype[svcno++] = "files";
  		return svcno;
  	}
  	return -1;
  }
  /*
  **  USERNAME -- return the user id of the logged in user.
--- 890,931 ----
  	}
  #endif
  
+ #if !defined(_USE_SUN_NSSWITCH_)
  	/* if the service file doesn't work, use an absolute fallback */
! # ifdef _USE_DEC_SVC_CONF_
    punt:
! # endif
  	for (svcno = 0; svcno < MAXMAPACTIONS; svcno++)
  		mapreturn[svcno] = 0;
  	svcno = 0;
  	if (strcmp(service, "aliases") == 0)
  	{
  		maptype[svcno++] = "files";
! # ifdef AUTO_NIS_ALIASES
! #  ifdef NISPLUS
  		maptype[svcno++] = "nisplus";
! #  endif
! #  ifdef NIS
  		maptype[svcno++] = "nis";
+ #  endif
  # endif
  		return svcno;
  	}
  	if (strcmp(service, "hosts") == 0)
  	{
! #  if NAMED_BIND
  		maptype[svcno++] = "dns";
! #  else
! #   if defined(sun) && !defined(BSD)
  		/* SunOS */
  		maptype[svcno++] = "nis";
+ #   endif
  #  endif
  		maptype[svcno++] = "files";
  		return svcno;
  	}
  	return -1;
+ #endif
  }
  /*
  **  USERNAME -- return the user id of the logged in user.
diff -cr sendmail-8.9.0/src/conf.h sendmail-8.9.1/src/conf.h
*** sendmail-8.9.0/src/conf.h	Tue May 19 16:36:04 1998
--- sendmail-8.9.1/src/conf.h	Thu Jun  4 14:32:01 1998
***************
*** 9,15 ****
   * the sendmail distribution.
   *
   *
!  *	@(#)conf.h	8.371 (Berkeley) 5/19/98
   */
  
  /*
--- 9,15 ----
   * the sendmail distribution.
   *
   *
!  *	@(#)conf.h	8.372 (Berkeley) 6/4/98
   */
  
  /*
***************
*** 63,68 ****
--- 63,69 ----
  # define MAXQFNAME	20		/* max qf file name length */
  # define MACBUFSIZE	4096		/* max expanded macro buffer size */
  # define TOBUFSIZE	512		/* max buffer to hold address list */
+ # define MAXSHORTSTR	203		/* max short string length */
  
  /**********************************************************************
  **  Compilation options.
diff -cr sendmail-8.9.0/src/daemon.c sendmail-8.9.1/src/daemon.c
*** sendmail-8.9.0/src/daemon.c	Tue May 19 16:36:06 1998
--- sendmail-8.9.1/src/daemon.c	Wed Jun 24 11:28:42 1998
***************
*** 15,23 ****
  
  #ifndef lint
  #ifdef DAEMON
! static char sccsid[] = "@(#)daemon.c	8.217 (Berkeley) 5/19/98 (with daemon mode)";
  #else
! static char sccsid[] = "@(#)daemon.c	8.217 (Berkeley) 5/19/98 (without daemon mode)";
  #endif
  #endif /* not lint */
  
--- 15,23 ----
  
  #ifndef lint
  #ifdef DAEMON
! static char sccsid[] = "@(#)daemon.c	8.220 (Berkeley) 6/24/98 (with daemon mode)";
  #else
! static char sccsid[] = "@(#)daemon.c	8.220 (Berkeley) 6/24/98 (without daemon mode)";
  #endif
  #endif /* not lint */
  
***************
*** 402,408 ****
  			    (outchannel = fdopen(t, "w")) == NULL)
  			{
  				syserr("cannot open SMTP server channel, fd=%d", t);
! 				exit(0);
  			}
  
  			InChannel = inchannel;
--- 402,408 ----
  			    (outchannel = fdopen(t, "w")) == NULL)
  			{
  				syserr("cannot open SMTP server channel, fd=%d", t);
! 				exit(EX_OK);
  			}
  
  			InChannel = inchannel;
***************
*** 416,422 ****
  			if (!xla_host_ok(RealHostName))
  			{
  				message("421 Too many SMTP sessions for this host");
! 				exit(0);
  			}
  #endif
  
--- 416,422 ----
  			if (!xla_host_ok(RealHostName))
  			{
  				message("421 Too many SMTP sessions for this host");
! 				exit(EX_OK);
  			}
  #endif
  
***************
*** 888,893 ****
--- 888,900 ----
  #endif
  
  		  default:
+ 			if (hp->h_length > sizeof addr.sa.sa_data)
+ 			{
+ 				syserr("makeconnection: long sa_data: family %d len %d",
+ 					hp->h_addrtype, hp->h_length);
+ 				mci_setstat(mci, EX_NOHOST, "5.1.2", NULL);
+ 				return EX_NOHOST;
+ 			}
  			bcopy(hp->h_addr,
  				addr.sa.sa_data,
  				hp->h_length);
***************
*** 2046,2052 ****
  	_res.retry = saveretry;
  #endif /* NAMED_BIND */
  
! 	if (hp != NULL && hp->h_name[0] != '[' && inet_addr(hp->h_name) == -1)
  		return denlstring((char *) hp->h_name, TRUE, TRUE);
  #if NETUNIX
  	else if (sap->sa.sa_family == AF_UNIX && sap->sunix.sun_path[0] == '\0')
--- 2053,2060 ----
  	_res.retry = saveretry;
  #endif /* NAMED_BIND */
  
! 	if (hp != NULL && hp->h_name[0] != '[' &&
! 	    inet_addr(hp->h_name) == INADDR_NONE)
  		return denlstring((char *) hp->h_name, TRUE, TRUE);
  #if NETUNIX
  	else if (sap->sa.sa_family == AF_UNIX && sap->sunix.sun_path[0] == '\0')
diff -cr sendmail-8.9.0/src/deliver.c sendmail-8.9.1/src/deliver.c
*** sendmail-8.9.0/src/deliver.c	Tue May 19 16:36:08 1998
--- sendmail-8.9.1/src/deliver.c	Tue Jun 30 23:05:35 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)deliver.c	8.349 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)deliver.c	8.353 (Berkeley) 6/30/98";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 942,948 ****
  	p = remotename(p, m, RF_SENDERADDR|RF_CANONICAL, &rcode, e);
  	if (strlen(p) >= (SIZE_T) sizeof rpathbuf)
  	{
! 		p = shortenstring(p, 203);
  		syserr("remotename: huge return %s", p);
  	}
  	snprintf(rpathbuf, sizeof rpathbuf, "%s", p);
--- 942,948 ----
  	p = remotename(p, m, RF_SENDERADDR|RF_CANONICAL, &rcode, e);
  	if (strlen(p) >= (SIZE_T) sizeof rpathbuf)
  	{
! 		p = shortenstring(p, MAXSHORTSTR);
  		syserr("remotename: huge return %s", p);
  	}
  	snprintf(rpathbuf, sizeof rpathbuf, "%s", p);
***************
*** 1073,1079 ****
  		if (m->m_maxsize != 0 && e->e_msgsize > m->m_maxsize)
  		{
  			e->e_flags |= EF_NO_BODY_RETN;
! 			to->q_status = "5.2.3";
  			usrerr("552 Message is too large; %ld bytes max", m->m_maxsize);
  			markfailure(e, to, NULL, EX_UNAVAILABLE);
  			giveresponse(EX_UNAVAILABLE, m, NULL, ctladdr, xstart, e);
--- 1073,1082 ----
  		if (m->m_maxsize != 0 && e->e_msgsize > m->m_maxsize)
  		{
  			e->e_flags |= EF_NO_BODY_RETN;
! 			if (bitnset(M_LOCALMAILER, to->q_mailer->m_flags))
! 				to->q_status = "5.2.3";
! 			else
! 				to->q_status = "5.3.4";
  			usrerr("552 Message is too large; %ld bytes max", m->m_maxsize);
  			markfailure(e, to, NULL, EX_UNAVAILABLE);
  			giveresponse(EX_UNAVAILABLE, m, NULL, ctladdr, xstart, e);
***************
*** 1275,1281 ****
  
  		/* make absolutely certain 0, 1, and 2 are in use */
  		snprintf(wbuf, sizeof wbuf, "%s... openmailer(%s)",
! 			shortenstring(e->e_to, 203), m->m_name);
  		checkfd012(wbuf);
  	}
  #endif
--- 1278,1284 ----
  
  		/* make absolutely certain 0, 1, and 2 are in use */
  		snprintf(wbuf, sizeof wbuf, "%s... openmailer(%s)",
! 			shortenstring(e->e_to, MAXSHORTSTR), m->m_name);
  		checkfd012(wbuf);
  	}
  #endif
***************
*** 1506,1512 ****
  		if (pipe(mpvect) < 0)
  		{
  			syserr("%s... openmailer(%s): pipe (to mailer)",
! 				shortenstring(e->e_to, 203), m->m_name);
  			if (tTd(11, 1))
  				printf("openmailer: NULL\n");
  			rcode = EX_OSERR;
--- 1509,1515 ----
  		if (pipe(mpvect) < 0)
  		{
  			syserr("%s... openmailer(%s): pipe (to mailer)",
! 				shortenstring(e->e_to, MAXSHORTSTR), m->m_name);
  			if (tTd(11, 1))
  				printf("openmailer: NULL\n");
  			rcode = EX_OSERR;
***************
*** 1518,1524 ****
  		if (mpvect[0] < 3 || mpvect[1] < 3)
  		{
  			syserr("%s... openmailer(%s): bogus mpvect %d %d",
! 				shortenstring(e->e_to, 203), m->m_name,
  				mpvect[0], mpvect[1]);
  			printopenfds(TRUE);
  			if (tTd(11, 1))
--- 1521,1527 ----
  		if (mpvect[0] < 3 || mpvect[1] < 3)
  		{
  			syserr("%s... openmailer(%s): bogus mpvect %d %d",
! 				shortenstring(e->e_to, MAXSHORTSTR), m->m_name,
  				mpvect[0], mpvect[1]);
  			printopenfds(TRUE);
  			if (tTd(11, 1))
***************
*** 1537,1548 ****
  		{
  			if (e->e_lockfp == NULL)
  				syserr("%s... openmailer(%s): overlapping mpvect %d %d",
! 					shortenstring(e->e_to, 203), m->m_name,
! 					mpvect[0], mpvect[1]);
  			else
  				syserr("%s... openmailer(%s): overlapping mpvect %d %d, lockfp = %d",
! 					shortenstring(e->e_to, 203), m->m_name,
! 					mpvect[0], mpvect[1], fileno(e->e_lockfp));
  		}
  #endif
  
--- 1540,1552 ----
  		{
  			if (e->e_lockfp == NULL)
  				syserr("%s... openmailer(%s): overlapping mpvect %d %d",
! 					shortenstring(e->e_to, MAXSHORTSTR),
! 					m->m_name, mpvect[0], mpvect[1]);
  			else
  				syserr("%s... openmailer(%s): overlapping mpvect %d %d, lockfp = %d",
! 					shortenstring(e->e_to, MAXSHORTSTR),
! 					m->m_name, mpvect[0], mpvect[1],
! 					fileno(e->e_lockfp));
  		}
  #endif
  
***************
*** 1553,1559 ****
  			if (pipe(rpvect) < 0)
  			{
  				syserr("%s... openmailer(%s): pipe (from mailer)",
! 					shortenstring(e->e_to, 203), m->m_name);
  				(void) close(mpvect[0]);
  				(void) close(mpvect[1]);
  				if (tTd(11, 1))
--- 1557,1564 ----
  			if (pipe(rpvect) < 0)
  			{
  				syserr("%s... openmailer(%s): pipe (from mailer)",
! 					shortenstring(e->e_to, MAXSHORTSTR),
! 					m->m_name);
  				(void) close(mpvect[0]);
  				(void) close(mpvect[1]);
  				if (tTd(11, 1))
***************
*** 1586,1592 ****
  		{
  			/* failure */
  			syserr("%s... openmailer(%s): cannot fork",
! 				shortenstring(e->e_to, 203), m->m_name);
  			(void) close(mpvect[0]);
  			(void) close(mpvect[1]);
  #if SMTP
--- 1591,1597 ----
  		{
  			/* failure */
  			syserr("%s... openmailer(%s): cannot fork",
! 				shortenstring(e->e_to, MAXSHORTSTR), m->m_name);
  			(void) close(mpvect[0]);
  			(void) close(mpvect[1]);
  #if SMTP
***************
*** 1772,1778 ****
  				if (dup2(rpvect[1], STDOUT_FILENO) < 0)
  				{
  					syserr("%s... openmailer(%s): cannot dup pipe %d for stdout",
! 						shortenstring(e->e_to, 203),
  						m->m_name, rpvect[1]);
  					_exit(EX_OSERR);
  				}
--- 1777,1783 ----
  				if (dup2(rpvect[1], STDOUT_FILENO) < 0)
  				{
  					syserr("%s... openmailer(%s): cannot dup pipe %d for stdout",
! 						shortenstring(e->e_to, MAXSHORTSTR),
  						m->m_name, rpvect[1]);
  					_exit(EX_OSERR);
  				}
***************
*** 1784,1790 ****
  				if (dup2(fileno(e->e_xfp), STDOUT_FILENO) < 0)
  				{
  					syserr("%s... openmailer(%s): cannot dup xscript %d for stdout",
! 						shortenstring(e->e_to, 203),
  						m->m_name, fileno(e->e_xfp));
  					_exit(EX_OSERR);
  				}
--- 1789,1795 ----
  				if (dup2(fileno(e->e_xfp), STDOUT_FILENO) < 0)
  				{
  					syserr("%s... openmailer(%s): cannot dup xscript %d for stdout",
! 						shortenstring(e->e_to, MAXSHORTSTR),
  						m->m_name, fileno(e->e_xfp));
  					_exit(EX_OSERR);
  				}
***************
*** 1793,1799 ****
  			if (dup2(STDOUT_FILENO, STDERR_FILENO) < 0)
  			{
  				syserr("%s... openmailer(%s): cannot dup stdout for stderr",
! 					shortenstring(e->e_to, 203), m->m_name);
  				_exit(EX_OSERR);
  			}
  
--- 1798,1805 ----
  			if (dup2(STDOUT_FILENO, STDERR_FILENO) < 0)
  			{
  				syserr("%s... openmailer(%s): cannot dup stdout for stderr",
! 					shortenstring(e->e_to, MAXSHORTSTR),
! 					m->m_name);
  				_exit(EX_OSERR);
  			}
  
***************
*** 1802,1808 ****
  			if (dup2(mpvect[0], STDIN_FILENO) < 0)
  			{
  				syserr("%s... openmailer(%s): cannot dup pipe %d for stdin",
! 					shortenstring(e->e_to, 203),
  					m->m_name, mpvect[0]);
  				_exit(EX_OSERR);
  			}
--- 1808,1814 ----
  			if (dup2(mpvect[0], STDIN_FILENO) < 0)
  			{
  				syserr("%s... openmailer(%s): cannot dup pipe %d for stdin",
! 					shortenstring(e->e_to, MAXSHORTSTR),
  					m->m_name, mpvect[0]);
  				_exit(EX_OSERR);
  			}
***************
*** 2186,2192 ****
  		/* make absolutely certain 0, 1, and 2 are in use */
  		snprintf(wbuf, sizeof wbuf, "%s... end of deliver(%s)",
  			e->e_to == NULL ? "NO-TO-LIST"
! 					: shortenstring(e->e_to, 203),
  			m->m_name);
  		checkfd012(wbuf);
  	}
--- 2192,2198 ----
  		/* make absolutely certain 0, 1, and 2 are in use */
  		snprintf(wbuf, sizeof wbuf, "%s... end of deliver(%s)",
  			e->e_to == NULL ? "NO-TO-LIST"
! 					: shortenstring(e->e_to, MAXSHORTSTR),
  			m->m_name);
  		checkfd012(wbuf);
  	}
***************
*** 3406,3412 ****
  		/* set group id list (needs /etc/group access) */
  		if (RealUserName != NULL && !DontInitGroups)
  		{
! 			if (initgroups(RealUserName, RealGid) == -1)
  				syserr("mailfile: initgroups(%s, %d) failed",
  					RealUserName, RealGid);
  		}
--- 3412,3418 ----
  		/* set group id list (needs /etc/group access) */
  		if (RealUserName != NULL && !DontInitGroups)
  		{
! 			if (initgroups(RealUserName, RealGid) == -1 && suidwarn)
  				syserr("mailfile: initgroups(%s, %d) failed",
  					RealUserName, RealGid);
  		}
***************
*** 3415,3421 ****
  			GIDSET_T gidset[1];
  
  			gidset[0] = RealGid;
! 			if (setgroups(1, gidset) == -1)
  				syserr("mailfile: setgroups() failed");
  		}
  
--- 3421,3427 ----
  			GIDSET_T gidset[1];
  
  			gidset[0] = RealGid;
! 			if (setgroups(1, gidset) == -1 && suidwarn)
  				syserr("mailfile: setgroups() failed");
  		}
  
***************
*** 3477,3486 ****
  		if (f == NULL)
  		{
  			message("554 cannot open %s: %s",
! 				shortenstring(filename, 203), errstring(errno));
  			exit(EX_CANTCREAT);
  		}
! 		if (filechanged(filename, fileno(f), &stb, sfflags))
  		{
  			message("554 file changed after open");
  			exit(EX_CANTCREAT);
--- 3483,3493 ----
  		if (f == NULL)
  		{
  			message("554 cannot open %s: %s",
! 				shortenstring(filename, MAXSHORTSTR),
! 				errstring(errno));
  			exit(EX_CANTCREAT);
  		}
! 		if (filechanged(filename, fileno(f), &stb))
  		{
  			message("554 file changed after open");
  			exit(EX_CANTCREAT);
diff -cr sendmail-8.9.0/src/domain.c sendmail-8.9.1/src/domain.c
*** sendmail-8.9.0/src/domain.c	Tue May 19 16:36:04 1998
--- sendmail-8.9.1/src/domain.c	Mon Jun 15 21:08:45 1998
***************
*** 14,22 ****
  
  #ifndef lint
  #if NAMED_BIND
! static char sccsid[] = "@(#)domain.c	8.75 (Berkeley) 5/19/98 (with name server)";
  #else
! static char sccsid[] = "@(#)domain.c	8.75 (Berkeley) 5/19/98 (without name server)";
  #endif
  #endif /* not lint */
  
--- 14,22 ----
  
  #ifndef lint
  #if NAMED_BIND
! static char sccsid[] = "@(#)domain.c	8.77 (Berkeley) 6/4/98 (with name server)";
  #else
! static char sccsid[] = "@(#)domain.c	8.77 (Berkeley) 6/4/98 (without name server)";
  #endif
  #endif /* not lint */
  
***************
*** 332,338 ****
  		if (strlen(host) >= (SIZE_T) sizeof MXHostBuf)
  		{
  			*rcode = EX_CONFIG;
! 			syserr("Host name %s too long", shortenstring(host, 203));
  			return -1;
  		}
  		snprintf(MXHostBuf, sizeof MXHostBuf, "%s", host);
--- 332,339 ----
  		if (strlen(host) >= (SIZE_T) sizeof MXHostBuf)
  		{
  			*rcode = EX_CONFIG;
! 			syserr("Host name %s too long",
! 			       shortenstring(host, MAXSHORTSTR));
  			return -1;
  		}
  		snprintf(MXHostBuf, sizeof MXHostBuf, "%s", host);
***************
*** 436,441 ****
--- 437,443 ----
  **	to generalize it at the moment.
  */
  
+ /* ARGSUSED3 */
  char *
  bestmx_map_lookup(map, name, av, statp)
  	MAP *map;
diff -cr sendmail-8.9.0/src/envelope.c sendmail-8.9.1/src/envelope.c
*** sendmail-8.9.0/src/envelope.c	Tue May 19 16:36:03 1998
--- sendmail-8.9.1/src/envelope.c	Thu Jun  4 14:51:30 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)envelope.c	8.115 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)envelope.c	8.117 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  #include "sendmail.h"
***************
*** 436,443 ****
  #ifdef TTYNAME
  	static char ybuf[60];			/* holds tty id */
  	register char *p;
- #endif /* TTYNAME */
  	extern char *ttyname();
  	extern void settime __P((ENVELOPE *));
  
  	/*
--- 436,443 ----
  #ifdef TTYNAME
  	static char ybuf[60];			/* holds tty id */
  	register char *p;
  	extern char *ttyname();
+ #endif /* TTYNAME */
  	extern void settime __P((ENVELOPE *));
  
  	/*
***************
*** 826,832 ****
  		if (LogLevel > 2)
  			sm_syslog(LOG_NOTICE, e->e_id,
  				"cannot prescan from (%s)",
! 				shortenstring(from, 203));
  		finis();
  	}
  	(void) rewrite(pvp, 3, 0, e);
--- 826,832 ----
  		if (LogLevel > 2)
  			sm_syslog(LOG_NOTICE, e->e_id,
  				"cannot prescan from (%s)",
! 				shortenstring(from, MAXSHORTSTR));
  		finis();
  	}
  	(void) rewrite(pvp, 3, 0, e);
diff -cr sendmail-8.9.0/src/err.c sendmail-8.9.1/src/err.c
*** sendmail-8.9.0/src/err.c	Tue May 19 16:36:05 1998
--- sendmail-8.9.1/src/err.c	Thu Jun  4 14:32:01 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)err.c	8.73 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)err.c	8.74 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 434,440 ****
  		sm_syslog(LOG_CRIT, CurEnv->e_id,
  			"SYSERR: putoutmsg (%s): error on output channel sending \"%s\": %s",
  			CurHostName == NULL ? "NO-HOST" : CurHostName,
! 			shortenstring(msg, 203), errstring(errno));
  }
  /*
  **  PUTERRMSG -- like putoutmsg, but does special processing for error messages
--- 434,440 ----
  		sm_syslog(LOG_CRIT, CurEnv->e_id,
  			"SYSERR: putoutmsg (%s): error on output channel sending \"%s\": %s",
  			CurHostName == NULL ? "NO-HOST" : CurHostName,
! 			shortenstring(msg, MAXSHORTSTR), errstring(errno));
  }
  /*
  **  PUTERRMSG -- like putoutmsg, but does special processing for error messages
***************
*** 541,547 ****
  	    strncmp(num, "251", 3) != 0)
  	{
  		(void) snprintf(eb, spaceleft, "%s... ",
! 			shortenstring(to, 203));
  		spaceleft -= strlen(eb);
  		while (*eb != '\0')
  			*eb++ &= 0177;
--- 541,547 ----
  	    strncmp(num, "251", 3) != 0)
  	{
  		(void) snprintf(eb, spaceleft, "%s... ",
! 			shortenstring(to, MAXSHORTSTR));
  		spaceleft -= strlen(eb);
  		while (*eb != '\0')
  			*eb++ &= 0177;
***************
*** 658,664 ****
  				bp += strlen(bp);
  			}
  			snprintf(bp, SPACELEFT(buf, bp), "%s",
! 				shortenstring(CurHostName, 203));
  			bp += strlen(buf);
  		}
  		if (SmtpPhase != NULL)
--- 658,664 ----
  				bp += strlen(bp);
  			}
  			snprintf(bp, SPACELEFT(buf, bp), "%s",
! 				shortenstring(CurHostName, MAXSHORTSTR));
  			bp += strlen(buf);
  		}
  		if (SmtpPhase != NULL)
***************
*** 672,685 ****
  		if (CurHostName == NULL)
  			break;
  		(void) snprintf(buf, sizeof buf, "Host %s is down",
! 			shortenstring(CurHostName, 203));
  		return (buf);
  
  	  case ECONNREFUSED:
  		if (CurHostName == NULL)
  			break;
  		(void) snprintf(buf, sizeof buf, "Connection refused by %s",
! 			shortenstring(CurHostName, 203));
  		return (buf);
  # endif
  
--- 672,685 ----
  		if (CurHostName == NULL)
  			break;
  		(void) snprintf(buf, sizeof buf, "Host %s is down",
! 			shortenstring(CurHostName, MAXSHORTSTR));
  		return (buf);
  
  	  case ECONNREFUSED:
  		if (CurHostName == NULL)
  			break;
  		(void) snprintf(buf, sizeof buf, "Connection refused by %s",
! 			shortenstring(CurHostName, MAXSHORTSTR));
  		return (buf);
  # endif
  
***************
*** 748,754 ****
  		if (CurHostName != NULL)
  		{
  			snprintf(bp, SPACELEFT(buf, bp), "%s: ",
! 				shortenstring(CurHostName, 203));
  			bp += strlen(bp);
  		}
  		snprintf(bp, SPACELEFT(buf, bp), "%s", dnsmsg);
--- 748,754 ----
  		if (CurHostName != NULL)
  		{
  			snprintf(bp, SPACELEFT(buf, bp), "%s: ",
! 				shortenstring(CurHostName, MAXSHORTSTR));
  			bp += strlen(bp);
  		}
  		snprintf(bp, SPACELEFT(buf, bp), "%s", dnsmsg);
diff -cr sendmail-8.9.0/src/headers.c sendmail-8.9.1/src/headers.c
*** sendmail-8.9.0/src/headers.c	Tue May 19 16:36:02 1998
--- sendmail-8.9.1/src/headers.c	Thu Jun  4 11:12:45 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)headers.c	8.126 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include <errno.h>
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)headers.c	8.127 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  # include <errno.h>
***************
*** 182,188 ****
  		(void) sendtolist(fvalue, NULLADDR, &e->e_errorqueue, 0, e);
  
  	/* if this means "end of header" quit now */
! 	if (bitset(H_EOH, hi->hi_flags))
  		return hi->hi_flags;
  
  	/*
--- 182,188 ----
  		(void) sendtolist(fvalue, NULLADDR, &e->e_errorqueue, 0, e);
  
  	/* if this means "end of header" quit now */
! 	if (!headeronly && bitset(H_EOH, hi->hi_flags))
  		return hi->hi_flags;
  
  	/*
***************
*** 254,259 ****
--- 254,263 ----
  	bcopy((char *) mopts, (char *) h->h_mflags, sizeof mopts);
  	*hp = h;
  	h->h_flags = hi->hi_flags;
+ 
+ 	/* strip EOH flag if parsing MIME headers */
+ 	if (headeronly)
+ 		h->h_flags &= ~H_EOH;
  	if (def)
  		h->h_flags |= H_DEFAULT;
  	if (cond)
diff -cr sendmail-8.9.0/src/main.c sendmail-8.9.1/src/main.c
*** sendmail-8.9.0/src/main.c	Tue May 19 16:36:03 1998
--- sendmail-8.9.1/src/main.c	Mon Jun  8 14:57:04 1998
***************
*** 19,25 ****
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)main.c	8.300 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  #define	_DEFINE
--- 19,25 ----
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)main.c	8.302 (Berkeley) 6/4/98";
  #endif /* not lint */
  
  #define	_DEFINE
***************
*** 1402,1408 ****
  			if (i < 0)
  				syserr("daemon: cannot fork");
  			if (i != 0)
! 				exit(0);
  
  			/* disconnect from our controlling tty */
  			disconnect(2, CurEnv);
--- 1402,1408 ----
  			if (i < 0)
  				syserr("daemon: cannot fork");
  			if (i != 0)
! 				exit(EX_OK);
  
  			/* disconnect from our controlling tty */
  			disconnect(2, CurEnv);
***************
*** 1621,1626 ****
--- 1621,1627 ----
  }
  
  
+ /* ARGSUSED */
  SIGFUNC_DECL
  intindebug(sig)
  	int sig;
***************
*** 1709,1714 ****
--- 1710,1716 ----
  **		Unlocks the current job.
  */
  
+ /* ARGSUSED */
  SIGFUNC_DECL
  intsig(sig)
  	int sig;
***************
*** 2136,2141 ****
--- 2138,2144 ----
  }
  
  
+ /* ARGSUSED */
  SIGFUNC_DECL
  sigusr1(sig)
  	int sig;
***************
*** 2145,2150 ****
--- 2148,2154 ----
  }
  
  
+ /* ARGSUSED */
  SIGFUNC_DECL
  sighup(sig)
  	int sig;
